"use strict";
const plugins_source_base_1 = require("./plugins-source-base");
const Future = require("fibers/future");
class NpmPluginsSource extends plugins_source_base_1.PluginsSourceBase {
    constructor($progressIndicator, $logger, $childProcess, $hostInfo, $npmService, $errors) {
        super($progressIndicator, $logger);
        this.$childProcess = $childProcess;
        this.$hostInfo = $hostInfo;
        this.$npmService = $npmService;
        this.$errors = $errors;
    }
    get progressIndicatorMessage() {
        return "Searching for plugins with npm search command.";
    }
    getPlugins(page, count) {
        let skip = page * count;
        return Future.fromResult(_.slice(this.plugins, skip, skip + count));
    }
    initializeCore(projectDir, keywords) {
        return (() => {
            this.plugins = this.$npmService.search(this.projectDir, keywords).wait();
        }).future()();
    }
}
exports.NpmPluginsSource = NpmPluginsSource;
