"use strict";
const Future = require("fibers/future");
class PluginsSourceBase {
    constructor($progressIndicator, $logger) {
        this.$progressIndicator = $progressIndicator;
        this.$logger = $logger;
    }
    initialize(projectDir, keywords) {
        return (() => {
            if (this._isInitialized) {
                return;
            }
            this.plugins = [];
            this.projectDir = projectDir;
            this._isInitialized = true;
            this.$logger.printInfoMessageOnSameLine(this.progressIndicatorMessage);
            this.$progressIndicator.showProgressIndicator(this.initializeCore(projectDir, keywords), 2000).wait();
        }).future()();
    }
    hasPlugins() {
        return !!(this.plugins && this.plugins.length);
    }
    getAllPlugins() {
        return Future.fromResult(this.plugins);
    }
}
exports.PluginsSourceBase = PluginsSourceBase;
